---
title: ConstantSourceNode.offset
slug: Web/API/ConstantSourceNode/offset
tags:
  - API
  - Audio
  - ConstantSourceNode
  - Media
  - Property
  - Read-only
  - Web Audio API
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The read-only <code>offset</code> property of the {{ domxref("ConstantSourceNode") }} interface returns a {{domxref("AudioParam")}} object indicating the numeric <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> value which is always returned by the source when asked for the next sample.</p>

<div class="note">
<p>While the <code>AudioParam</code> named <code>offset</code> is read-only, the <code>value</code> property within is not. So you can change the value of <code>offset</code> by setting the value of <code>ConstantSourceNode.offset.value</code>:</p>

<pre class="brush: js notranslate">myConstantSourceNode.offset.value = newValue;</pre>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>offsetParameter</em> = <em>ConstantAudioNode</em>.offset;

let <em>offset</em> = <em>ConstantSourceNode</em>.offset.value;
<em>ConstantSourceNode</em>.offset.value = <em>newValue</em>;</pre>

<h3 id="Value">Value</h3>

<p>An {{ domxref("AudioParam") }} object indicating the <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> value returned for every sample by this node. The default value is 1.0.</p>

<p>To access the <code>offset</code> parameter's current value, access the parameter's <code>value</code> property, as shown in the syntax box above.</p>

<h2 id="Example">Example</h2>

<p>This example shows how to set up a <code>ConstantSourceNode</code> so its <code>offset</code> is used as the input to a pair of {{domxref("GainNode")}}s; this snippet is derived from the complete example you can find in <a href="/en-US/docs/Web/API/Web_Audio_API/Controlling_multiple_parameters_with_ConstantSourceNode">Controlling multiple parameters with ConstantSourcenode</a>.</p>

<pre class="brush: js notranslate">gainNode2 = context.createGain();
gainNode3 = context.createGain();
gainNode2.gain.value = gainNode3.gain.value = 0.5;

volumeSliderControl.value = gainNode2.gain.value;

constantSource = context.createConstantSource();
constantSource.connect(gainNode2.gain);
constantSource.connect(gainNode3.gain);</pre>

<p>First, the gain nodes are created and configured, and a slider control's value is set to match the gain on the two nodes. Then we create a new {{domxref("ConstantSourceNode")}} and make it the source for the two gain nodes' {{domxref("GainNode.gain")}} values. Each of those values is also an {{domxref("AudioParam")}}.</p>

<p>Let's say we have an event handler (for {{event("click")}} events, in this case) which needs to respond by altering the value of the two gain nodes. With the linkage above in place, that can be done using this simple event handler:</p>

<pre class="brush: js notranslate">function handleClickEvent(event) {
  constantSource.offset.value = volumeSliderControl.value;
}</pre>

<p>All this function has to do is fetch the current value of the slider control we're using to control the paired nodes' gains, then store that value into the <code>ConstantSourceNode</code>'s <code>offset</code> parameter. That's done by changing the contents of its {{domxref("AudioParam.value")}} property. The two gain nodes quickly adopt the new volume level.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-constantsourcenode-offset', 'offset')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ConstantSourceNode.offset")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("ConstantSourceNode")}}</li>
 <li>{{domxref("AudioNode")}}</li>
 <li>{{domxref("AudioParam")}}</li>
</ul>
